package
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.system.ApplicationDomain;
	import flash.system.LoaderContext;
	
	[SWF(width = 960, height = 640, backgroundColor = '0x000000', frameRate = 60)]
	public class Main extends Sprite
	{
		public function Main():void
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			IFlash.setSize(960, 640);//2D项目中设置场景尺寸
			IFlash.setOrientationEx(1); //是否为横屏模式
			IFlash.setBgcolor("#000000"); //背景色
			IFlash.showInfo(true); //是否显示帧率
			
			loadAsset();
		}
		
		private function loadAsset():void
		{
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, assetLoadComplete);
			loader.load(new URLRequest("assets/layaFlashAsset.swf"), new LoaderContext(true, ApplicationDomain.currentDomain));
		}
		
		private function assetLoadComplete(event:Event):void
		{
			var loaderInfo:LoaderInfo = event.target as LoaderInfo;
			loaderInfo.removeEventListener(Event.COMPLETE, assetLoadComplete);
			
			var container:Sprite = new Sprite();
			var content:MovieClip = loaderInfo.content as MovieClip;
			var stageAsset:MovieClip = content.getChildAt(0) as MovieClip;
			
			if (!stageAsset)
			{
				trace("stageAsset is null.");
				return;
			}
			
			stageAsset.width = 220;
			stageAsset.height = 200;
			container.addChild(stageAsset);
			
			var appDomain:ApplicationDomain = ApplicationDomain.currentDomain;
			if (!appDomain || !appDomain.hasDefinition("asset.Dragon"))
			{
				trace("asset.Dragon is null.");
				return;
			}
			
			var cls:Class = appDomain.getDefinition("asset.Dragon") as Class;
			var dragon:MovieClip = new cls();
			dragon.width = 240;
			dragon.height = 200;
			dragon.x = 300;
			dragon.y = stageAsset.y;
			container.addChild(dragon);
			container.x = (stage.stageWidth - container.width) / 2;
			container.y = (stage.stageHeight - container.height) / 2;
			addChild(container);
		}
	}
}